//modifiedList.h for circular singly linked lists


// This is the file to include in your code if you want access to the
// complete LList template class

// First, get the declaration for the base list class
#include "LIST.h"
#include "LINK.h"


// Linked list implementation
template <class Elem> class LList: public List<Elem> {
private:
  Link<Elem>* head;       // Pointer to list header (dummy node)
  Link<Elem>* fence;      // Last element on left side
  int count;
  void init() {           // Intialization routine
    fence = head = new Link<Elem>;
    count=0;                //tail->next=head;
  }
  void removeall() {   // Return link nodes to free store
	  while(count!=0)                
      fence=head;                        
      head = head->next;                     
      delete fence;                     
    }
  
public:
  LList(int size=DefaultListSize) { init(); }
  ~LList() { removeall(); }  // Destructor
  void clear() { removeall(); init(); }
  bool insert(const Elem&);
  bool append(const Elem&);
  bool remove(Elem&);
  void setStart()
    { fence = head; count=0;}
  //void setEnd()
    //{ fence = tail; leftcnt += rightcnt; rightcnt = 0; } (no need for setEnd function)
  void prev();
  void next() 
      { fence = fence->next; }  
  
  //int leftLength() const  { return leftcnt; }  not needed
  int Length() const { return count; }
  bool setPos(int pos);
  bool getValue(Elem& it) const {
    if(Length() == 0) return false;
    it = fence->next->element;
    return true;
  }
  void print() const;
};

template <class Elem> // Insert at front of right partition
bool LList<Elem>::insert(const Elem& item) {
  fence->next = new Link<Elem>(item, fence->next);   
  count++;
  return true;
}

/*template <class Elem> // Append Elem to end of the list
bool LList<Elem>::append(const Elem& item) {
  tail=tail->next=new Link<Elem>(item,head) //pointer of tail will point to head
  rightcnt++;
  return true;
}*/  //append function not needed because there is no end

// Remove and return first Elem in right partition
template <class Elem> bool LList<Elem>::remove(Elem& it) {
  if(fence->next==head) return false;
  it = fence->next->element;       // Remember value
  Link<Elem>* ltemp = fence->next; // Remember link node
  fence->next = ltemp->next;       // Remove from list
  delete ltemp;                    // Reclaim space
  count--;
  return true;
}

// Move fence one step left; no change if left is empty
template <class Elem> void LList<Elem>::prev() {
  Link<Elem>* temp = head;
  while (temp->next!=fence) temp=temp->next;
  fence = temp;
}

// Set the size of left partition to pos
template <class Elem> bool LList<Elem>::setPos(int pos) {
  if ((pos < 0) || (pos > count)) return false;
  fence = head;
  for(int i=0; i<pos; i++) fence = fence->next;
  return true;
}

template <class Elem> void LList<Elem>::print() const {
  Link<Elem>* temp = head;
  cout << "< ";
  while (temp != fence) {
    cout << temp->next->element << " ";
    temp = temp->next;
  }
  cout << "| ";
  while (temp->next != head) {
    cout << temp->next->element << " ";
    temp = temp->next;
  }
  cout << ">\n";
}
