// This is the file to include in your code if you want access to the
// complete AQueue template class

// First, get the declaration for the base stack class
#include "queue.h"

// Array-based queue implementation
template <class Elem> class AQueue: public Queue<Elem> {
private:

	bool isEmpty;

  int size;                  // Maximum size of queue
  int front;                 // Index of front element
  int rear;                  // Index of rear element
  Elem *listArray;           // Array holding queue elements
public:
	AQueue(int sz=10){
	size=sz;
	rear=front=0;
	listArray=new Elem[size];
	isEmpty=true;
}
 
  
  ~AQueue() { delete [] listArray; } // Destructor
  void clear() { front = rear; isEmpty=true; }
 
  bool enqueue(const Elem& it){
	if (((rear+1) % size) == front) 
	  return false;  // Full
	else if(length()==0) //empty
	{
		front = rear = 0;
		listArray[0]=it;
		isEmpty=false;
		return true;}

	else
	{	rear=(rear+1) % size;
		listArray[rear]=it;
		return true;}

}
  
  bool dequeue(Elem& it){
	if(length()==0) return false;
	else if (length()==1)
	{
		it = listArray[front];
		isEmpty=true;     
		return true;}
	else 
	{
		it = listArray[front];
		front=(front+1)% size;
		return true;}
}

  bool frontValue(Elem& it) const {
    if (length() == 0) return false;  // Empty
    it = listArray[front];
    return true;
  }
  virtual int length() const
   { if(((rear+size)-front)%size+1==1){
	  if(isEmpty==true)
		  return 0;
	  else 
		  return 1;
	}
	 else return ((rear+size) - front) % size +1; }
};
