// First, get the declaration for the base stack class
#include "stack.h"

// Array-based stack implementation
template <class Elem> class AStack: public Stack<Elem> {
private:
  int size;                 // Maximum size of stack
  int top1;                 // Index for top element
  int top2;
  Elem *listArray;          // Array holding stack elements
public:
  AStack(int sz =100)     // Constructor
    { size = sz;  top1 = 0; top2=size;  listArray = new Elem[size]; }
  
  ~AStack() { delete[] listArray; }  // Destructor
  
  void clear() { top1 = 0; top2= size;}

  bool push1(const Elem& item) {
    if (top2 == top1 +1) return false; // Stack is full
    else { 
		listArray[top1++] = item;
		
		 return true; }
  }

  bool push2(const Elem& item) {
    if (top2 == top1 +1) return false; // Stack is full
    else { 
		listArray[top2--] = item; 
		 return true; }
  }

  bool pop1(Elem& it) {            // Pop top element
    if (top1 == 0) return false;
    else { it = listArray[--top1];  return true; }
  }

  bool pop2(Elem& it) {            // Pop top element
    if (top2 == size) return false;
    else { it = listArray[++top2];  return true; }
  }


  bool topValue1(Elem& it) const { // Return top element
    if (top1 == 0) return false;
    else { it = listArray[top1-1];  return true; }
  }

    bool topValue2(Elem& it) const { // Return top element
    if (top2 == size) return false;
    else { it = listArray[top2+1];  return true; }
  }

  int length1() const { return top1; }

  int length2() const { return size-top2; }
};
